<template>
  <q-container>
    <div class="row">
      <div class="col" v-if="!$q.screen.lt.sm">
        <q-img
          src="~assets/background/auth_login.png"
          alt="Guest image Placeholder"
          width="50vw"
          height="100vh"
        />
      </div>
      <div class="col" :class="{ 'mobile-right-content': $q.screen.lt.sm }">
        <q-layout :class="{ 'mobile-right-layout': $q.screen.lt.sm }">
          <q-img
            src="~assets/background/auth_register.png"
            alt="Guest image Placeholder"
            width="100vw"
            height="140px"
            v-if="$q.screen.lt.sm"
          />

          <q-header
            class="q-mt-md q-mx-sm bg-transparent"
            v-if="!$q.screen.lt.sm"
          >
            <q-toolbar>
              <q-toolbar-title class="text-left text-grey-7"> </q-toolbar-title>

              <q-btn
                v-if="ROUTE_PATH === '/forgot-password'"
                unelevated
                label="LOG IN"
                type="submit"
                class="btn-lg btn--shade-1 text-white"
                @click="$router.push('login')"
              />

              <q-btn
                v-else
                unelevated
                label="SIGN UP"
                type="submit"
                class="btn-lg btn--shade-1 text-white"
                @click="$router.push('register')"
              />
            </q-toolbar>
          </q-header>

          <q-page-container>
            <q-page
              :style-fn="
                !$q.screen.lt.sm
                  ? setPageHeight
                  : () => {
                      return 'min-height: 0';
                    }
              "
              class="flex justify-center items-center"
            >
              <div
                class="row q-px-lg q-pt-md"
                :class="{ 'q-py-lg': !$q.screen.lt.sm }"
              >
                <q-btn
                  unelevated
                  text
                  label="BACK"
                  class="btn-md btn-back"
                  icon="arrow_back"
                  @click="goBack"
                  v-if="$q.screen.lt.sm"
                />

                <div class="col-12">
                  <div
                    class="text-center q-mb-lg"
                    :class="{ 'q-my-xl': !$q.screen.lt.sm }"
                  >
                    <div
                      class="q-mb-lg"
                      :class="{ 'q-my-lg': !$q.screen.lt.sm }"
                    >
                      <img
                        alt="Vigan City Logo"
                        src="~assets/logo.svg"
                        :width="$q.screen.lt.sm ? '70' : '100'"
                        :height="$q.screen.lt.sm ? '70' : '100'"
                      />
                    </div>
                    <p class="title-headline">Welcome to Vigan City's</p>
                    <p class="title-1">Job Matching Portal</p>
                  </div>
                </div>

                <div class="col-12 justify-center">
                  <slot />
                </div>
              </div>
            </q-page>
          </q-page-container>

          <footer-layout />
        </q-layout>
      </div>
    </div>
  </q-container>
</template>

<script>
import { defineComponent, ref } from "vue";
import FooterLayout from "./sections/FooterLayout.vue";
import usePageRouter from "src/hooks/pageRouter";

export default defineComponent({
  components: { FooterLayout },
  name: "AuthLayout",
  setup() {
    const { router } = usePageRouter();
    const ROUTE_PATH = ref(null);
    const setPageHeight = (offset) => {
      // "offset" is a Number (pixels) that refers to the total
      // height of header + footer that occupies on screen,
      // based on the QLayout "view" prop configuration

      // this is actually what the default style-fn does in Quasar
      ROUTE_PATH.value = router.currentRoute.value.path;
      return { minHeight: offset ? `calc(100vh - ${offset}px)` : "100vh" };
    };

    const goBack = () => {
      console.log(window.history);
      if (window.history.state.back == null) {
        router.push("register");
      } else {
        window.history.back();
      }
    };

    return {
      ROUTE_PATH,
      setPageHeight,
      goBack,
    };
  },
});
</script>

<style lang="scss" scoped>
.mobile-right-content {
  position: relative;

  &::before {
    content: "";
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    // background-image: url("~assets/background/auth_login.png");
    // background-position: center;
    // filter: grayscale(100%) blur(2px);
    z-index: 2;
  }

  .mobile-right-layout {
    // background: rgba(255, 255, 255, 0.8);
    z-index: 3;
  }
}

.q-footer {
  position: absolute !important;
}

p {
  margin: 0 0 12px !important;
}
</style>
